/*
** pseudo random integer number generator 
*/

static unsigned int _x;

void randomize(unsigned int r)
{
    _x= r;
} //randomize


// 16-bit Random number Linear feedback shift register 
// maximal LFSR taps are: 16,15, 13, 4
unsigned int rand( void)
{
    int i;
    
    // repeat maximal LFSR to generate 16 new bits
    for (i=0; i<16; i++)
        _x =  (_x<<1) + (((_x>>15) ^ (_x>>14) ^ (_x>>12) ^ (_x>>3)) & 1);
        
    return _x;
}// rand
